(define (linux-errno-alist) '((E2BIG . 7)(EACCES . 13)(EADDRINUSE . 98)(EADDRNOTAVAIL . 99)(EAFNOSUPPORT . 97)(EAGAIN . 11)(EALREADY . 114)(EBADF . 9)(EBADMSG . 74)(EBUSY . 16)(ECANCELED . 125)(ECHILD . 10)(ECONNABORTED . 103)(ECONNREFUSED . 111)(ECONNRESET . 104)(EDEADLK . 35)(EDESTADDRREQ . 89)(EDOM . 33)(EDQUOT . 122)(EEXIST . 17)(EFAULT . 14)(EFBIG . 27)(EHOSTUNREACH . 113)(EIDRM . 43)(EILSEQ . 84)(EINPROGRESS . 115)(EINTR . 4)(EINVAL . 22)(EIO . 5)(EISCONN . 106)(EISDIR . 21)(ELOOP . 40)(EMFILE . 24)(EMLINK . 31)(EMSGSIZE . 90)(EMULTIHOP . 72)(ENAMETOOLONG . 36)(ENETDOWN . 100)(ENETRESET . 102)(ENETUNREACH . 101)(ENFILE . 23)(ENOBUFS . 105)(ENODATA . 61)(ENODEV . 19)(ENOENT . 2)(ENOEXEC . 8)(ENOLCK . 37)(ENOLINK . 67)(ENOMEM . 12)(ENOMSG . 42)(ENOPROTOOPT . 92)(ENOSPC . 28)(ENOSR . 63)(ENOSTR . 60)(ENOSYS . 38)(ENOTCONN . 107)(ENOTDIR . 20)(ENOTEMPTY . 39)(ENOTRECOVERABLE . 131)(ENOTSOCK . 88)(ENOTSUP . 95)(ENOTTY . 25)(ENXIO . 6)(EOPNOTSUPP . 95)(EOVERFLOW . 75)(EOWNERDEAD . 130)(EPERM . 1)(EPIPE . 32)(EPROTO . 71)(EPROTONOSUPPORT . 93)(EPROTOTYPE . 91)(ERANGE . 34)(EROFS . 30)(ESPIPE . 29)(ESRCH . 3)(ESTALE . 116)(ETIME . 62)(ETIMEDOUT . 110)(ETXTBSY . 26)(EWOULDBLOCK . 11)(EXDEV . 18)))

(define (macosx-errno-alist) '((E2BIG . 7)(EACCES . 13)(EADDRINUSE . 48)(EADDRNOTAVAIL . 49)(EAFNOSUPPORT . 47)(EAGAIN . 35)(EALREADY . 37)(EBADF . 9)(EBADMSG . 94)(EBUSY . 16)(ECANCELED . 89)(ECHILD . 10)(ECONNABORTED . 53)(ECONNREFUSED . 61)(ECONNRESET . 54)(EDEADLK . 11)(EDESTADDRREQ . 39)(EDOM . 33)(EDQUOT . 69)(EEXIST . 17)(EFAULT . 14)(EFBIG . 27)(EHOSTUNREACH . 65)(EIDRM . 90)(EILSEQ . 92)(EINPROGRESS . 36)(EINTR . 4)(EINVAL . 22)(EIO . 5)(EISCONN . 56)(EISDIR . 21)(ELOOP . 62)(EMFILE . 24)(EMLINK . 31)(EMSGSIZE . 40)(EMULTIHOP . 95)(ENAMETOOLONG . 63)(ENETDOWN . 50)(ENETRESET . 52)(ENETUNREACH . 51)(ENFILE . 23)(ENOBUFS . 55)(ENODATA . 96)(ENODEV . 19)(ENOENT . 2)(ENOEXEC . 8)(ENOLCK . 77)(ENOLINK . 97)(ENOMEM . 12)(ENOMSG . 91)(ENOPROTOOPT . 42)(ENOSPC . 28)(ENOSR . 98)(ENOSTR . 99)(ENOSYS . 78)(ENOTCONN . 57)(ENOTDIR . 20)(ENOTEMPTY . 66)(ENOTRECOVERABLE . 104)(ENOTSOCK . 38)(ENOTSUP . 45)(ENOTTY . 25)(ENXIO . 6)(EOPNOTSUPP . 102)(EOVERFLOW . 84)(EOWNERDEAD . 105)(EPERM . 1)(EPIPE . 32)(EPROTO . 100)(EPROTONOSUPPORT . 43)(EPROTOTYPE . 41)(ERANGE . 34)(EROFS . 30)(ESPIPE . 29)(ESRCH . 3)(ESTALE . 70)(ETIME . 101)(ETIMEDOUT . 60)(ETXTBSY . 26)(EWOULDBLOCK . 35)(EXDEV . 18)))

(define (windows-errno-alist) '((E2BIG . 7)(EACCES . 13)(EADDRINUSE . 100)(EADDRNOTAVAIL . 101)(EAFNOSUPPORT . 102)(EAGAIN . 11)(EALREADY . 103)(EBADF . 9)(EBADMSG . 104)(EBUSY . 16)(ECANCELED . 105)(ECHILD . 10)(ECONNABORTED . 106)(ECONNREFUSED . 107)(ECONNRESET . 108)(EDEADLK . 36)(EDESTADDRREQ . 109)(EDOM . 33)(EEXIST . 17)(EFAULT . 14)(EFBIG . 27)(EHOSTUNREACH . 110)(EIDRM . 111)(EILSEQ . 42)(EINPROGRESS . 112)(EINTR . 4)(EINVAL . 22)(EIO . 5)(EISCONN . 113)(EISDIR . 21)(ELOOP . 114)(EMFILE . 24)(EMLINK . 31)(EMSGSIZE . 115)(ENAMETOOLONG . 38)(ENETDOWN . 116)(ENETRESET . 117)(ENETUNREACH . 118)(ENFILE . 23)(ENOBUFS . 119)(ENODATA . 120)(ENODEV . 19)(ENOENT . 2)(ENOEXEC . 8)(ENOLCK . 39)(ENOLINK . 121)(ENOMEM . 12)(ENOMSG . 122)(ENOPROTOOPT . 123)(ENOSPC . 28)(ENOSR . 124)(ENOSTR . 125)(ENOSYS . 40)(ENOTCONN . 126)(ENOTDIR . 20)(ENOTEMPTY . 41)(ENOTRECOVERABLE . 127)(ENOTSOCK . 128)(ENOTSUP . 129)(ENOTTY . 25)(ENXIO . 6)(EOPNOTSUPP . 130)(EOVERFLOW . 132)(EOWNERDEAD . 133)(EPERM . 1)(EPIPE . 32)(EPROTO . 134)(EPROTONOSUPPORT . 135)(EPROTOTYPE . 136)(ERANGE . 34)(EROFS . 30)(ESPIPE . 29)(ESRCH . 3)(ETIME . 137)(ETIMEDOUT . 138)(ETXTBSY . 139)(EWOULDBLOCK . 140)(EXDEV . 18)))

(define (freebsd-errno-alist) '((EPERM . 1)(ENOENT . 2)(ESRCH . 3)(EINTR . 4)(EIO . 5)(ENXIO . 6)(E2BIG . 7)(ENOEXEC . 8)(EBADF . 9)(ECHILD . 10)(EDEADLK . 11)(ENOMEM . 12)(EACCES . 13)(EFAULT . 14)(ENOTBLK . 15)(EBUSY . 16)(EEXIST . 17)(EXDEV . 18)(ENODEV . 19)(ENOTDIR . 20)(EISDIR . 21)(EINVAL . 22)(ENFILE . 23)(EMFILE . 24)(ENOTTY . 25)(ETXTBSY . 26)(EFBIG . 27)(ENOSPC . 28)(ESPIPE . 29)(EROFS . 30)(EMLINK . 31)(EPIPE . 32)(EDOM . 33)(ERANGE . 34)(EAGAIN . 35)(EINPROGRESS . 36)(EALREADY . 37)(ENOTSOCK . 38)(EDESTADDRREQ . 39)(EMSGSIZE . 40)(EPROTOTYPE . 41)(ENOPROTOOPT . 42)(EPROTONOSUPPORT . 43)(ESOCKTNOSUPPORT . 44)(EOPNOTSUPP . 45)(EPFNOSUPPORT . 46)(EAFNOSUPPORT . 47)(EADDRINUSE . 48)(EADDRNOTAVAIL . 49)(ENETDOWN . 50)(ENETUNREACH . 51)(ENETRESET . 52)(ECONNABORTED . 53)(ECONNRESET . 54)(ENOBUFS . 55)(EISCONN . 56)(ENOTCONN . 57)(ESHUTDOWN . 58)(ETIMEDOUT . 60)(ECONNREFUSED . 61)(ELOOP . 62)(ENAMETOOLONG . 63)(EHOSTDOWN . 64)(EHOSTUNREACH . 65)(ENOTEMPTY . 66)(EPROCLIM . 67)(EUSERS . 68)(EDQUOT . 69)(ESTALE . 70)(EBADRPC . 72)(ERPCMISMATCH . 73)(EPROGUNAVAIL . 74)(EPROGMISMATCH . 75)(EPROCUNAVAIL . 76)(ENOLCK . 77)(ENOSYS . 78)(EFTYPE . 79)(EAUTH . 80)(ENEEDAUTH . 81)(EIDRM . 82)(ENOMSG . 83)(EOVERFLOW . 84)(ECANCELED . 85)(EILSEQ . 86)(ENOATTR . 87)(EDOOFUS . 88)(EBADMSG . 89)(EMULTIHOP . 90)(ENOLINK . 91)(EPROTO . 92)(ENOTCAPABLE . 93)(ECAPMODE . 94)(ENOTRECOVERABLE . 95)(EOWNERDEAD . 96)(EINTEGRITY . 97)))

(define (netbsd-errno-alist) '((EPERM . 1)(ENOENT . 2)(ESRCH . 3)(EINTR . 4)(EIO . 5)(ENXIO . 6)(E2BIG . 7)(ENOEXEC . 8)(EBADF . 9)(ECHILD . 10)(EDEADLK . 11)(ENOMEM . 12)(EACCES . 13)(EFAULT . 14)(ENOTBLK . 15)(EBUSY . 16)(EEXIST . 17)(EXDEV . 18)(ENODEV . 19)(ENOTDIR . 20)(EISDIR . 21)(EINVAL . 22)(ENFILE . 23)(EMFILE . 24)(ENOTTY . 25)(ETXTBSY . 26)(EFBIG . 27)(ENOSPC . 28)(ESPIPE . 29)(EROFS . 30)(EMLINK . 31)(EPIPE . 32)(EDOM . 33)(ERANGE . 34)(EAGAIN . 35)(EINPROGRESS . 36)(EALREADY . 37)(ENOTSOCK . 38)(EDESTADDRREQ . 39)(EMSGSIZE . 40)(EPROTOTYPE . 41)(ENOPROTOOPT . 42)(EPROTONOSUPPORT . 43)(ESOCKTNOSUPPORT . 44)(EOPNOTSUPP . 45)(EPFNOSUPPORT . 46)(EAFNOSUPPORT . 47)(EADDRINUSE . 48)(EADDRNOTAVAIL . 49)(ENETDOWN . 50)(ENETUNREACH . 51)(ENETRESET . 52)(ECONNABORTED . 53)(ECONNRESET . 54)(ENOBUFS . 55)(EISCONN . 56)(ENOTCONN . 57)(ESHUTDOWN . 58)(ETOOMANYREFS . 59)(ETIMEDOUT . 60)(ECONNREFUSED . 61)(ELOOP . 62)(ENAMETOOLONG . 63)(EHOSTDOWN . 64)(EHOSTUNREACH . 65)(ENOTEMPTY . 66)(EPROCLIM . 67)(EUSERS . 68)(EDQUOT . 69)(ESTALE . 70)(EREMOTE . 71)(EBADRPC . 72)(ERPCMISMATCH . 73)(EPROGUNAVAIL . 74)(EPROGMISMATCH . 75)(EPROCUNAVAIL . 76)(ENOLCK . 77)(ENOSYS . 78)(EFTYPE . 79)(EAUTH . 80)(ENEEDAUTH . 81)(EIDRM . 82)(ENOMSG . 83)(EOVERFLOW . 84)(EILSEQ . 85)(ENOTSUP . 86)(ECANCELED . 87)(EBADMSG . 88)(ENODATA . 89)(ENOSR . 90)(ENOSTR . 91)(ETIME . 92)(ENOATTR . 93)(EMULTIHOP . 94)(ENOLINK . 95)(EPROTO . 96)))

(define (openbsd-errno-alist) '((EPERM . 1)(ENOENT . 2)(ESRCH . 3)(EINTR . 4)(EIO . 5)(ENXIO . 6)(E2BIG . 7)(ENOEXEC . 8)(EBADF . 9)(ECHILD . 10)(EDEADLK . 11)(ENOMEM . 12)(EACCES . 13)(EFAULT . 14)(ENOTBLK . 15)(EBUSY . 16)(EEXIST . 17)(EXDEV . 18)(ENODEV . 19)(ENOTDIR . 20)(EISDIR . 21)(EINVAL . 22)(ENFILE . 23)(EMFILE . 24)(ENOTTY . 25)(ETXTBSY . 26)(EFBIG . 27)(ENOSPC . 28)(ESPIPE . 29)(EROFS . 30)(EMLINK . 31)(EPIPE . 32)(EDOM . 33)(ERANGE . 34)(EAGAIN . 35)(EINPROGRESS . 36)(EALREADY . 37)(ENOTSOCK . 38)(EDESTADDRREQ . 39)(EMSGSIZE . 40)(EPROTOTYPE . 41)(ENOPROTOOPT . 42)(EPROTONOSUPPORT . 43)(ESOCKTNOSUPPORT . 44)(EOPNOTSUPP . 45)(EPFNOSUPPORT . 46)(EAFNOSUPPORT . 47)(EADDRINUSE . 48)(EADDRNOTAVAIL . 49)(ENETDOWN . 50)(ENETUNREACH . 51)(ENETRESET . 52)(ECONNABORTED . 53)(ECONNRESET . 54)(ENOBUFS . 55)(EISCONN . 56)(ENOTCONN . 57)(ESHUTDOWN . 58)(ETOOMANYREFS . 59)(ETIMEDOUT . 60)(ECONNREFUSED . 61)(ELOOP . 62)(ENAMETOOLONG . 63)(EHOSTDOWN . 64)(EHOSTUNREACH . 65)(ENOTEMPTY . 66)(EPROCLIM . 67)(EUSERS . 68)(EDQUOT . 69)(ESTALE . 70)(EBADRPC . 72)(ERPCMISMATCH . 73)(EPROGUNAVAIL . 74)(EPROGMISMATCH . 75)(EPROCUNAVAIL . 76)(ENOLCK . 77)(ENOSYS . 78)(EFTYPE . 79)(EAUTH . 80)(ENEEDAUTH . 81)(EIPSEC . 82)(ENOATTR . 83)(EILSEQ . 84)(ENOMEDIUM . 85)(EMEDIUMTYPE . 86)(EOVERFLOW . 87)(ECANCELED . 88)(EIDRM . 89)(ENOMSG . 90)(ENOTSUP . 91)(EBADMSG . 92)(ENOTRECOVERABLE . 93)(EOWNERDEAD . 94)(EPROTO . 95)))

(define (solaris-errno-alist) '((EPERM . 1)(ENOENT . 2)(ESRCH . 3)(EINTR . 4)(EIO . 5)(ENXIO . 6)(E2BIG . 7)(ENOEXEC . 8)(EBADF . 9)(ECHILD . 10)(EAGAIN . 11)(ENOMEM . 12)(EACCES . 13)(EFAULT . 14)(ENOTBLK . 15)(EBUSY . 16)(EEXIST . 17)(EXDEV . 18)(ENODEV . 19)(ENOTDIR . 20)(EISDIR . 21)(EINVAL . 22)(ENFILE . 23)(EMFILE . 24)(ENOTTY . 25)(ETXTBSY . 26)(EFBIG . 27)(ENOSPC . 28)(ESPIPE . 29)(EROFS . 30)(EMLINK . 31)(EPIPE . 32)(EDOM . 33)(ERANGE . 34)(ENOMSG . 35)(EIDRM . 36)(ECHRNG . 37)(EL2NSYNC . 38)(EL3HLT . 39)(EL3RST . 40)(ELNRNG . 41)(EUNATCH . 42)(ENOCSI . 43)(EL2HLT . 44)(EDEADLK . 45)(ENOLCK . 46)(ECANCELED . 47)(ENOTSUP . 48)(EDQUOT . 49)(ENOSTR . 60)(ENODATA . 61)(ETIME . 62)(ENOSR . 63)(ENOPKG . 65)(EPROTO . 71)(EBADMSG . 77)(ENAMETOOLONG . 78)(EOVERFLOW . 79)(ENOTUNIQ . 80)(EBADFD . 81)(EREMCHG . 82)(ELIBACC . 83)(ELIBBAD . 84)(ELIBSCN . 85)(ELIBMAX . 86)(ELIBEXEC . 87)(EILSEQ . 88)(ENOSYS . 89)(ELOOP . 90)(ESTART . 91)(ESTRPIPE . 92)(ENOTEMPTY . 93)(EUSERS . 94)(ENOTSOCK . 95)(EDESTADDRREQ . 96)(EMGSIZE . 97)(EPROTOTYPE . 98)(ENOPROTOOPT . 99)(EPROTONOSUPPORT . 120)(ESOCKTNOSUPPORT . 121)(EOPNOTSUPP . 122)(EPFNOSUPPORT . 123)(EAFNOSUPPORT . 124)(EADDRINUSE . 125)(EADDRNOTAVAIL . 126)(ENETDOWN . 127)(ENETUNREACH . 128)(ENETRESET . 129)(ECONNABORTED . 130)(ECONNRESET . 131)(ENOBUFS . 132)(EISCONN . 133)(ENOTCONN . 134)(ESHUTDOWN . 143)(ETOOMANYREFS . 144)(ETIMEDOUT . 145)(ECONNREFUSED . 146)(EHOSTDOWN . 147)(EHOSTUNREACH . 148)(EALREADY . 149)(EINPROGRESS . 150)(ESTALE . 151)))
